package game;

import java.util.Comparator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.stream.Collectors;

public class Tower {
	
	private String[] towerValues;
	
	public Tower(String values) {
		towerValues = values.split(" ");
	}

	public int getTowerValue(int n) {
		return Integer.parseInt(towerValues[n]);
	}
	
	public int getTowerSum() {
		int sum = 0;
		for(int i = 0; i < 10; i++) {
			sum += Integer.parseInt(towerValues[i]);
		}
		return sum;
	}
	
	public Integer[] getSortedTowers() {
		Integer[] sortedIndices = new Integer[10];
		int br = 0;
		Map<Integer, Integer> towersSorted = new LinkedHashMap<>();
		for(int i = 0; i < 10; i++) {
			towersSorted.put(i, Integer.parseInt(towerValues[i]));
		}
		towersSorted = towersSorted.entrySet().stream()
                .sorted(Map.Entry.comparingByValue(Comparator.reverseOrder()))
                .collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue,
                        (oldValue, newValue) -> oldValue, LinkedHashMap::new));
		for(Map.Entry<Integer, Integer> entry : towersSorted.entrySet()) {
			sortedIndices[br++] = entry.getKey();
		}
		return sortedIndices;
	}
}
